unit HiProcInfo;  {  ProcInfo (    ) ver 1.00 }

interface

uses Windows,KOL,KOLComObj,ActiveX,Share,Debug;

const STGM_default =STGM_READWRITE + STGM_SHARE_EXCLUSIVE;
      STGM_BASE    =STGM_READ + STGM_SHARE_EXCLUSIVE;

type
  TScriptLanguage = (slVBScript, slJScript);
  
type
 THiProcInfo = class(TDebug)
   private
      Name              : string;
      Manufacturer      : string;
      Description       : string;
      SocketDesignation : string;
      MaxClockSpeed     : string;
      ExtClock          : string;
      Version           : string;
      L2CacheSize       : string;
      L2CacheSpeed      : string;
      Architecture      : string;
      Availability      : string;
      CurrentVoltage    : string;
      ProcessorId       : string;
      Status            : string;
      
   public
      _event_onInfo: THI_Event;
      _event_onEndEnum: THI_Event;
      constructor Create;
      destructor Destroy; override; 
      procedure _work_doInfo(var _Data:TData; Index:word);
      procedure _var_Name(var _Data:TData; Index:word);
      procedure _var_Manufacturer(var _Data:TData; Index:word);
      procedure _var_Description(var _Data:TData; Index:word);
      procedure _var_SocketDesignation(var _Data:TData; Index:word);
      procedure _var_MaxClockSpeed(var _Data:TData; Index:word);
      procedure _var_ExtClock(var _Data:TData; Index:word);
      procedure _var_Version(var _Data:TData; Index:word);
      procedure _var_L2CacheSize(var _Data:TData; Index:word);
      procedure _var_L2CacheSpeed(var _Data:TData; Index:word);
      procedure _var_Architecture(var _Data:TData; Index:word);
      procedure _var_Availability(var _Data:TData; Index:word);
      procedure _var_CurrentVoltage(var _Data:TData; Index:word);
      procedure _var_ProcessorId(var _Data:TData; Index:word);
      procedure _var_Status(var _Data:TData; Index:word);

 end;

implementation


const
  NULL_GUID: TGUID = '{00000000-0000-0000-0000-000000000000}';

var
  ScriptCLSIDs: array[TScriptLanguage] of TGUID;

const
  ScriptProgIDs: array[TScriptLanguage] of PWideChar = (
    'VBScript',
    'JScript'
  );

procedure InitCLSIDs;
var
  L: TScriptLanguage;
begin
  for L := Low(TScriptLanguage) to High(TScriptLanguage) do
    if CLSIDFromProgID(ScriptProgIDs[L], ScriptCLSIDs[L]) <> S_OK
      then ScriptCLSIDs[L] := NULL_GUID;
end;

constructor THiProcInfo.Create;
begin
  inherited;
  OleInit;
  InitCLSIDs;
end;

destructor THiProcInfo.Destroy;
begin
   OleUnInit;
   inherited;
end;

function GetObject(const name:string; accs:dword=STGM_default): Variant;
var   err:HResult;
      bo:tBINDOPTS;
      res:IDispatch;
      nm:widestring;
begin
   nm := name;
   fillchar(bo,sizeof(bo),0);
   with bo do begin cbStruct := sizeof(bo);
      grfFlags := BIND_MAYBOTHERUSER;
      grfMode := accs;
   end;
   err := CoGetObject(  @nm[1] , @bo , IDispatch , @res );
   OleCheck(err);
   Result := res;
end;

procedure THiProcInfo._work_doInfo;
var   objService: Variant;
      objProcessor: Variant; 
      colProcessor: Variant;
      oEnum : IEnumvariant;
      iValue : PLongint;
      str: string;
      Num: integer;

      function Trim(s:string): string;
      var   st :integer;
      begin
         if Length(s) > 0 then begin
         st := 1;
         while (st <= Length(s))and(s[st] = ' ') do inc(st);
         delete(s,1,st-1);
         st := Length(s);
         while (st > 0)and(s[st] = ' ') do dec(st);
         delete(s,st+1,Length(s) - st);
         Result := s;
      end;
      
end;      
begin
   objService := GetObject('winmgmts:{impersonationLevel=impersonate}!\\.\root\CIMV2');
   colProcessor := objService.ExecQuery('SELECT * FROM Win32_Processor');
   oEnum := IUnknown(colProcessor._NewEnum) as IEnumVariant;
   iValue := nil;
   while oEnum.Next(1,objProcessor,iValue) = 0 do begin
      Name              := Trim(VarToStr(objProcessor.Name));
      Manufacturer      := Trim(VarToStr(objProcessor.Manufacturer));
      Description       := Trim(VarToStr(objProcessor.Description));
      SocketDesignation := Trim(VarToStr(objProcessor.SocketDesignation));
      MaxClockSpeed     := Trim(VarToStr(objProcessor.MaxClockSpeed));
      ExtClock          := Trim(VarToStr(objProcessor.ExtClock));
      Version           := Trim(VarToStr(objProcessor.Version));
      L2CacheSize       := Trim(VarToStr(objProcessor.L2CacheSize));
      L2CacheSpeed      := Trim(VarToStr(objProcessor.L2CacheSpeed));
      Num               := str2int(VarToStr(objProcessor.Architecture));
      case Num of
         0: Architecture := 'x86';
         1: Architecture := 'MIPS';
         2: Architecture := 'Alpha';
         3: Architecture := 'PowerPC';
      end;
      Num               := str2int(VarToStr(objProcessor.Availability));
      case Num of
         1 : Availability := 'Other';
         2 : Availability := 'Unknown';
         3 : Availability := 'Running - Full Power';
         4 : Availability := 'Warning';
         13: Availability := 'Power Save - Unknown';
         14: Availability := 'Power Save - Low Power Mode';
         15: Availability := 'Power Save - Standby';
         18: Availability := 'Paused';
      end;
      CurrentVoltage    := double2str(str2int(VarToStr(objProcessor.CurrentVoltage))/10);
      ProcessorId       := Trim(VarToStr(objProcessor.ProcessorId));
      Status            := Trim(VarToStr(objProcessor.Status));

      str :=  Name + ';' + Manufacturer + ';' + Description + ';' + Version  + ';' +
              Architecture + ';' + SocketDesignation + ';' + ProcessorId + ';' +
              CurrentVoltage + ';' + Availability + ';' + ExtClock + ';' + 
              MaxClockSpeed + ';' + L2CacheSize + ';' + L2CacheSpeed + ';' + Status;
      _hi_onEvent(_event_onInfo);
      objProcessor := Unassigned;
   end;
   _hi_CreateEvent(_Data, @_event_onEndEnum, colProcessor.Count); 
end;

procedure THiProcInfo._var_Name;begin dtString(_Data,Name);end;
procedure THiProcInfo._var_Manufacturer;begin dtString(_Data,Manufacturer);end;
procedure THiProcInfo._var_Description;begin dtString(_Data,Description);end;
procedure THiProcInfo._var_SocketDesignation;begin dtString(_Data,SocketDesignation);end;
procedure THiProcInfo._var_MaxClockSpeed;begin dtString(_Data,MaxClockSpeed);end;
procedure THiProcInfo._var_ExtClock;begin dtString(_Data,ExtClock);end;
procedure THiProcInfo._var_Version;begin dtString(_Data,Version);end;
procedure THiProcInfo._var_L2CacheSize;begin dtString(_Data,L2CacheSize);end;
procedure THiProcInfo._var_L2CacheSpeed;begin dtString(_Data,L2CacheSpeed);end;
procedure THiProcInfo._var_Architecture;begin dtString(_Data,Architecture);end;
procedure THiProcInfo._var_Availability;begin dtString(_Data,Availability);end;
procedure THiProcInfo._var_CurrentVoltage;begin dtString(_Data,CurrentVoltage);end;
procedure THiProcInfo._var_ProcessorId;begin dtString(_Data,ProcessorId);end;
procedure THiProcInfo._var_Status;begin dtString(_Data,Status);end;

end.


